local color, power, percent = "FFFFFF", 0, 0 --Define some locals
--local options, opttitle, optslider, optfonttitle, optlock
local pf = CreateFrame("Frame", "ClassicPowerText_PF")
local pt = pf:CreateTexture(nil, "BACKGROUND")
local pp = pf:CreateFontString("ClassicPowerText_PP", "ARTWORK", "GameFontNormalHuge")

pf:SetFrameStrata("MEDIUM")
pf:SetWidth(50)
pf:SetHeight(50)
pf:Show()
       
pp:SetPoint("CENTER", pf)
pp:SetText("|cffffffffCPT|r")
pp:Show()

function ClassicPowerText_OnEvent(self, event, ...)
	if (event == "UNIT_POWER" and ... == "player") then
		local _, class = UnitClass("player")
		if class == "PALADIN" then
			power = (UnitPowerMax("player", 9) / UnitPower("player", 9)) -- holy power
		elseif class == "DRUID" then
			local form = GetShapeshiftForm()
			if form == 5 then
				power = (UnitPowerMax("player", 8) / UnitPower("player", 8)) -- eclipse
			end
		elseif class == "WARLOCK" then
			power = (UnitPowerMax("player", 7) / UnitPower("player", 7)) -- soul shards
		else
			power = (UnitPowerMax("player") / UnitPower("player"))
		end
		percent = (100 / power)
		ClassicPowerText_UpdatePower()
	elseif (event == "PLAYER_ENTERING_WORLD") then
		pf:SetAlpha(CPT_DB.alpha)
	end
end

pf:RegisterEvent("UNIT_POWER")
--ClassicPowerText:RegisterEvent("PLAYER_REGEN_DISABLED")
--ClassicPowerText:RegisterEvent("PLAYER_REGEN_ENABLED")
pf:RegisterEvent("PLAYER_ENTERING_WORLD")
pf:SetScript("OnEvent", ClassicPowerText_OnEvent)
pf:SetScript("OnUpdate", ClassicPowerText_OnUpdate)

function ClassicPowerText_UpdatePower()
	local typeInt, typeString = UnitPowerType("player")
	local default_begin = ""; local default_end = "";
	if CPT_DB.enabled == "1" then
		local newValue = CPT_DB.color
		if (percent < 4) then pp:Hide() else pp:Show() end
		if newValue == "0" then --default
			if (percent >= 80) then --green
				color = "00CD00"
			elseif (percent < 80 and percent >= 40) then --yellow
				color = "FFFF00"
			elseif (percent < 40 and percent >= 20) then -- orange
				color = "FF6600"
			elseif (percent < 20 and percent >= 4) then --red
				color = "FF0033"
			end
			default_begin = "|cFF"..color; default_end = "|r"
		elseif newValue == "1" then -- class colors
			local _, class = UnitClass("player")
			local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
			pp:SetTextColor(r, g, b, CPT_DB.alphain)
			default_begin = ""; default_end = ""
		elseif newValue == "2" then -- power colors
			local r, g, b = PowerBarColor[typeString].r, PowerBarColor[typeString].g, PowerBarColor[typeString].b
			pp:SetTextColor(r, g, b, CPT_DB.alphain)
			default_begin = ""; default_end = ""
		elseif newValue == "3" then -- custom colors
			local r = CPT_DB.color_picker.r
			local g = CPT_DB.color_picker.g
			local b = CPT_DB.color_picker.b
			local o = CPT_DB.color_picker.opacity
			pp:SetTextColor(r, g, b, o)
			default_begin = ""; default_end = ""
		end
		local _, class = UnitClass("player")
		if class == "PALADIN" then
			pp:SetText(default_begin..UnitPower("player", 9)..default_end) -- holy power
		elseif class == "DRUID" then
			local form = GetShapeshiftForm()
			if form == 5 then
				pp:SetText(default_begin..UnitPower("player", 8)..default_end) -- eclipse
			else
				pp:SetText(default_begin..UnitPower("player")..default_end)
			end
		elseif class == "WARLOCK" then
			pp:SetText(default_begin..UnitPower("player", 7)..default_end) -- soul shards
		else
			pp:SetText(default_begin..UnitPower("player")..default_end)
		end
	end
end

local timer = 0
function ClassicPowerText_OnUpdate(self, elapsed)
	timer = timer - elapsed
	
	if timer < 0 then
		pp:SetFont(STANDARD_TEXT_FONT, CPT_DB.size)
		self:SetScript("OnUpdate", nil)
	end
end

function ClassicPowerText_Size(newValue)
	pp:SetFont(STANDARD_TEXT_FONT, tonumber(newValue))
end

function ClassicPowerText_Alpha(newValue)
    pf:SetAlpha(tonumber(newValue))
end

function ClassicPowerText_Lock(newValue)
    if newValue == "1" then
        pt:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
        pt:SetAllPoints(pf)
        pf:SetFrameLevel(5)
        pf:SetFrameStrata("DIALOG")
        pf:SetMovable(true)
        pf:EnableMouse(true)
        pf:RegisterForDrag("LeftButton")
        pf:SetClampedToScreen(true)
		pf:SetAlpha(1)
        pf:SetScript("OnDragStart", pf.StartMoving)
        pf:SetScript("OnDragStop", function() pf:StopMovingOrSizing()
        CPT_DB.x, CPT_DB.y = pf:GetLeft(), pf:GetBottom() end)
    elseif newValue == "0" then
        pt:SetTexture(nil)
        pf:SetFrameLevel(0)
        pf:SetFrameStrata("MEDIUM")
        pf:SetMovable(false)
        pf:EnableMouse(false)
		pf:SetAlpha(CPT_DB.alpha)
    end
end

function ClassicPowerText_Toggle(newValue)
	if newValue == "0" then
		pf:Hide()
		pf:UnregisterEvent("UNIT_POWER")
		CPT_DB.enabled = "0"
	elseif newValue == "1" then
		pf:Show()
		pf:RegisterEvent("UNIT_POWER")
		pf:ClearAllPoints()
		if CPT_DB.first == true then
			pf:SetPoint("CENTER", UIParent, "CENTER", CPT_DB.x, CPT_DB.y)
			CPT_DB.first = false
		else
			pf:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", CPT_DB.x, CPT_DB.y)
		end
		CPT_DB.enabled = "1"
	end
end

SlashCmdList["CLASSICPOWERTEXT"] = function(msg)
	ClassicPowerText_SlashHandler(string.lower(msg));
end

SLASH_CLASSICPOWERTEXT1 = "/classicpowertext"
SLASH_CLASSICPOWERTEXT2 = "/cpt"
SLASH_CLASSICPOWERTEXT3 = "/cptext"

function ClassicPowerText_SlashHandler(msg)
	if CPT_DB.enabled == "0" then ClassicPowerText_Toggle("1") end
	local frame = LibStub("Portfolio").GetOptionsFrame("ClassicPowerText")
	InterfaceOptionsFrame_OpenToCategory(frame)
end