-- <= == == == == == == == == == == == == =>
-- => Option Registration
-- <= == == == == == == == == == == == == =>

if (not CPT_DB) then
	CPT_DB = {
		x = 0;
		y = 0;
		first = true;
	}
end

if (not CPT_DB.enabled) then CPT_DB.enabled = "1" end

local Portfolio = LibStub and LibStub("Portfolio")
if not Portfolio then return end

local function callback(id, value, isGUI, isUpdate) 
	Portfolio.Print(id.." callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")")
end

local function colorCallback(id, color, isGUI, isUpdate) 
	(SELECTED_CHAT_FRAME or DEFAULT_CHAT_FRAME)
		:AddMessage(id.." Updated. callback( { r="..tostring(color.r):format("%.2f")..", g="
		..tostring(color.g):format("%.2f")..", b="..tostring(color.b):format("%.2f")..", opacity="
		..tostring(color.opacity).." }, "..tostring(isGUI)..", "..tostring(isUpdate)..") ", 
		color.r, color.g, color.b) 
end

local optionTable = {
	id="ClassicPowerText";
	text="ClassicPowerText";
	addon="ClassicPowerText";
	about=true;
	options = {
		{
			id = "enabled";
			text = "Enable";
			tooltipText = "Check this to enable ClassicPowerText.";
			type = CONTROLTYPE_CHECKBOX;
			defaultValue = "1";
			callback = ClassicPowerText_Toggle
		};
		{
			id = "unlocked";
			text = "Unlock Text";
			tooltipText = "Check this to unlock the text.";
			type = CONTROLTYPE_CHECKBOX;
			defaultValue = "0";
			callback = ClassicPowerText_Lock
		};
		{
            id = "size";
            text = "Text Font Size (%.1f)";
            tooltipText = "Adjust the font size of the text.";
            minText = "Small";
            maxText = "Large";
            minValue = 10;
            maxValue = 30;
            valueStep = 1;
            type = CONTROLTYPE_SLIDER;
            defaultValue = "15";
            callback = ClassicPowerText_Size
        };
		{
			id = "alpha";
			text = "Alpha (%.1f)";
			tooltipText = "The transparency of the text.";
			minText = "Light";
			maxText = "Solid";
			minValue = 0.1;
			maxValue = 1;
			valueStep = 0.1;
			type = CONTROLTYPE_SLIDER;
			defaultValue = "1";
			callback = ClassicPowerText_Alpha
		};
        --[[{
            id = "alphaout";
            text = "Alpha O.O.C. (%.1f)";
            tooltipText = "The transparency of the text while out of combat.";
            minText = "Light";
            maxText = "Solid";
            minValue = 0;
            maxValue = 1;
            valueStep = 0.1;
            type = CONTROLTYPE_SLIDER;
            defaultValue = "0.5";
            callback = ClassicPowerText_AlphaOut
        };]]
		{
			id = "color";
			headerText = "Text Color";
			type = CONTROLTYPE_DROPDOWN;
			defaultValue = "0";
			menuList = {
				{
					text = "Percent Gradient (G, Y, R)";
					value = "0";
				};
				{
					text = "Class Colors";
					value = "1";
				};
				{
					text = "Power Colors";
					value = "2";
				};
				{
					text = "Custom (Color Picker)";
					value = "3";
				};
			};
		};
		{
			id = "color_picker";
			text = "Custom Color";
			type = CONTROLTYPE_COLORPICKER;
			hasOpacity = true;
			defaultValue = {r=0.5, g=1, b=0.75, opacity=1};
			point = {"LEFT", "color", "RIGHT", 40, 0};
		};
	};
	savedVarTable = "CPT_DB";
}

Portfolio.RegisterOptionSet(optionTable)